/*
 * FastaChecker.java
 *
 * Created on Oct 18, 2007, 2:38:10 PM
 *
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nl.uu.chem.bioinformatics.statquant.fastachecker;

import nl.uu.chem.bioinformatics.statquant.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Observable;
import java.util.Observer;

/**
 *
 * @author Toorn101
 */
public class FastaChecker implements Observer {

    private Observer observer;

    public void setObserver(Observer observer) {
        this.observer = observer;
    }

    /**
     * Check all peptides against a given FASTA database and see whether or not there are
     * more than one hit for the peptide, making it ambiguous in ratio calculations.
     *
     * @param fastafile file with sequences to check against
     * @param regex The regular expression to use to get the protein identifier
     * @return number of excluded peptides
     */
    public void check(ProtsAndPepsDataHandler dataHandler, File fastafile, String regex) throws FileNotFoundException, IOException {
        FastaCheckerThreadPool checker = new FastaCheckerThreadPool(dataHandler, fastafile, regex);
        checker.addObserver(this);
        new Thread(checker).start();
    }

    @Override
    public synchronized void update(Observable o, Object arg) {
        observer.update(o, arg);
    }
}
